package ps3;

public class TestGraph {
	public static void error(String s) {
		System.err.println(s);
		System.exit(0);
	}

	public static void main(String[] args) {
		try {
			// We try all the StringGraph implementation with the same tests.
			// (It would be good to compare the results from the different
			// implementations.)
			for (char c = 'A'; c <= 'C'; c++) {
				String cname = "ps3.StringGraph" + c;
				System.out.println ("Testing class: " + cname);
				Class graphclass = Class.forName(cname);
				StringGraph sg = (StringGraph) graphclass.newInstance();

				System.out.println("empty: " + sg.toString());
				System.out.print("test adjacent: ");
				try {
					sg.getAdjacent("A");
					error("test adjacent: No Exception!");
				} catch (NoNodeException e) {
					System.out.println("okay");
				}

				// Add some nodes
				for (int i = 1; i <= 10; i++) {
					sg.addNode("node" + i);
				}

				System.out.println("after adding: " + sg);

				// Add some edges
				for (int i = 1; i <= 10; i += 2) {
					for (int j = 2; j <= 10; j += 2) {
						sg.addEdge("node" + i, "node" + j);
					}
				}

				System.out.print("Add bad edge: ");
				try {
					sg.addEdge("bad", "node2");
				} catch (NoNodeException e) {
					System.out.println("okay");
				}

				System.out.print("Add bad edge: ");
				try {
					sg.addEdge("node6", "bad");
				} catch (NoNodeException e) {
					System.out.println("okay");
				}

				System.out.print("Add duplicate edge: ");
				try {
					sg.addEdge("node1", "node2");
				} catch (DuplicateException e) {
					System.out.println("okay");
				}

				for (int i = 1; i <= 10; i++) {
					System.out.println("Adjacent node" + i + ": "
							+ sg.getAdjacent("node" + i));
				}

				System.out.println("Graph: " + sg);
			}
		} catch (Exception e) {
			error("Bad exception: " + e);
		}
	}
}
